Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.fdk.core
Class CoreCategoryManager

    java.lang.Object
      oracle.ifs.fdk.impl.CategoryManagerImpl
          oracle.ifs.fdk.core.CoreCategoryManager

All Implemented Interfaces:
  java.rmi.Remote, CategoryManager

    public class CoreCategoryManager

extends CategoryManagerImpl

The metadata management base implementation.

Constructor Summary
`CoreCategoryManager()` Constructor required for web services
`CoreCategoryManager(FdkSession session)` Constructor.

Method Summary
`Item` | `addMetaDataAttribute(long categoryId, NamedValue attributedef, AttributeRequest[] attrrequest)` adds a metadata attribute.
`protected Item` | `addMetaDataCategoryAttribute(long categoryId, NamedValue attributedef, AttributeRequest[] attrrequest)` Deprecated. use addMetaDataAttribute
`protected void` | `checkInvalidAttributes(java.util.Map attrMap)` if any attributes remain, then they are invalid
`Item` | `createCategorySubClass(NamedValue[] attributes, AttributeRequest[] attrrequest)` Creates a Category subclass.
`void` | `deleteCategory(long catId)` Delete a Category instance.
`void` | `freeCategoryClass(long mdscatId)` Frees a category class.
`protected Item[]` | `getConfigurationMetaDataCategories(long folderId, int categorytype, AttributeRequest[] requestedAttributes, java.lang.String configClassName)` Deprecated. remove when getRequiredCategories is removed.
`protected FdkSessionImpl` | `getConnectedSession()` Return the web service session.
`Item[]` | `getRequiredCategories(long folderId, AttributeRequest[] requestedAttributes)` Gets the required categories for a folder.
`protected Item[]` | `getRequiredMetaDataCategories(long folderId, AttributeRequest[] attrReqs, java.lang.String cfgClassName)` Returns the RequiredCategories of the given folder, or null if none.
`protected boolean` | `isWebServiceCall()` Returns `true` if the current call was made from a web services client.
`protected NamedValue[]` | `login(FdkCredential c, NamedValue[] options, AttributeRequest[] userAttributes)` Internal login method used by web services login managers.
`Item` | `modifyCategorySubClass(long mdscatId, NamedValue[] attributes, AttributeRequest[] attrrequest)` Modifies the given Category subclass.
`Item` | `modifyMetaDataAttribute(long attributeId, NamedValue attributedef, AttributeRequest[] attrrequest)` modify a category attribute.
`void` | `referenceTypes(TypeReference ref)` Dummy web service method to create a reference to data types used in the web services to insure that they are defined in the WSDL.
`void` | `removeCategoryAttribute(long categoryId, java.lang.String attributename)` Deprecated. use removeMetaDataAttribute
`void` | `removeCategoryConfiguration(long folderId)` remove the existing CategoryConfiguration for a Folder.
`void` | `removeMetaDataAttribute(long attributeId)` removes a category attribute.
`protected void` | `removeMetaDataCategoryAttribute(long categoryId, java.lang.String attributeName)` Deprecated. use removeMetaDataAttribute
`protected void` | `removeMetaDataConfiguration(long folderId, java.lang.String configClassName)`
`void` | `setCategoryConfiguration(long folderId, NamedValue[] config)` Sets or updates the CategoryConfiguration for a Folder.
`protected void` | `setMetaDataConfiguration(long folderId, NamedValue[] config, java.lang.String configClassName)`
`Item` | `updateCategory(long catId, NamedValue[] attrs, AttributeRequest[] attributes)` Updates an existing Category.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CoreCategoryManager

    public CoreCategoryManager()

  Constructor required for web services

### CoreCategoryManager

    public CoreCategoryManager(FdkSession session)

  Constructor.

Method Detail

### getRequiredCategories

    public Item[] getRequiredCategories(long folderId,
                                        AttributeRequest[] requestedAttributes)
                                 throws FdkException

  Description copied from interface: `CategoryManager`
  Gets the required categories for a folder.

  Parameters:
    `folderId` - folder for to fetch the categories
    `requestedAttributes` - list of attributes needed for each item
  Returns:
    required categories for this folder; null if no category is marked as required.

  Throws:
    `FdkException` - if the operation fails

### setCategoryConfiguration

    public void setCategoryConfiguration(long folderId,
                                         NamedValue[] config)
                                  throws FdkException

  Description copied from interface: `CategoryManager`
  Sets or updates the CategoryConfiguration for a Folder.

  The entire configuration will replaced as a set and not added to the existing one. AttributeOverrides are replaced as a set. To change one, you must specify all overrides. To remove all overrides, explicitly set ATTRIBUTE_OVERRIDE to null.

  Parameters:
    `folderId` - the folder for which to set the Category configuration
    `config` - the Category configuration options to set; must include one or more of the following Attributes:
    - notation: {Attribute name, Attribute type}
    - {Attributes.ALLOW_ALL_CATEGORIES, Boolean}
    - {Attributes.ALLOWED_CATEGORIES, long[]} each element is an Category Class.
    - {Attributes.CONFIGURATION_FINAL, Boolean}
    - {Attributes.CONFIGURATION_ENABLED, Boolean}
    - {Attributes.ATTRIBUTE_OVERRIDE, NamedValue []} can be specificied multiple times, one for each attribute.
      - {Attributes.ATTRIBUTE_OVERRIDE_CATEGORY_CLASS, id}
      - {Attributes.ATTRIBUTE_OVERRIDE_ATTRIBUTE, id}
      - {Attributes.ATTRIBUTE_OVERRIDE_DEFAULT, Object}
      - {Attributes.ATTRIBUTE_OVERRIDE_DEFAULT_SET, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_PROMPT, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_REQUIRED, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDE_SETTABLE, Boolean}
  Throws:
    `FdkException` - if the operation fails.

### removeCategoryConfiguration

    public void removeCategoryConfiguration(long folderId)
                                     throws FdkException

  Description copied from interface: `CategoryManager`
  remove the existing CategoryConfiguration for a Folder.

  Parameters:
    `folderId` - the folder for which to remove the Category configuration
  Throws:
    `FdkException` - if the operation fails.

### updateCategory

    public Item updateCategory(long catId,
                               NamedValue[] attrs,
                               AttributeRequest[] attributes)
                        throws FdkException

  Description copied from interface: `CategoryManager`
  Updates an existing Category.

  Note, this method will not return the new category if this update causes the associated document to create a new version. Use `FileManager.updateDocuments` instead, which will return the new document Item (and its associated categories, which will reflect the update).

  Parameters:
    `catId` - Category to be updated
    `attrs` - the attributes to update.
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {custom_attribute_name, value}
    `attributes` - requested attributes for each item, or null.
  Returns:
    the updated Category.
  Throws:
    `FdkException` - if the operation fails

### deleteCategory

    public void deleteCategory(long catId)
                        throws FdkException

  Description copied from interface: `CategoryManager`
  Delete a Category instance.

  Parameters:
    `catId` - the category ID to be deleted.
  Throws:
    `FdkException` - if the operation fails.

### createCategorySubClass

    public Item createCategorySubClass(NamedValue[] attributes,
                                       AttributeRequest[] attrrequest)
                                throws FdkException

  Description copied from interface: `CategoryManager`
  Creates a Category subclass.

  Given an array of Attributes that describes a class object, create the Category class object and return the classobject id. If Workflow is enabled AND 'CreateUserCategory' is workflow enabled, then an item of type 'REQUEST' is returned. Otherwise, the function returns the created category. UI implementers should check the type of the Item returned and act accordingly (If it's a request, inform user the request needs to be approved before the category can be created.).

  Parameters:
    `attributes` - array of attributes for creating the category class
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.SUPERCLASS, long}
    - {Attributes.CLASS_ABSTRACT, Boolean}
    - {Attributes.CLASS_FINAL, Boolean}
    - {Attributes.CLASS_HIDDEN, Boolean}
    - {Attributes.CATEGORY_COPY_ON_VERSION, Boolean}
    - {Attributes.METADATA_ATTRIBUTES, NamedValueSet[]}
      - {Attributes.NAME, String},
      - {Attributes.ATTRIBUTE_NAME, String}, optional, must start with "CUSTOM_"
      - {Attributes.ATTRIBUTE_REQUIRED, Boolean}
      - {Attributes.ATTRIBUTE_SETTABLE, Boolean}
      - {Attributes.ATTRIBUTE_UPDATEABLE, Boolean}
      - {Attributes.ATTRIBUTE_HIDDEN, Boolean}
      - {Attributes.ATTRIBUTE_OVERRIDEABLE, Boolean}
      - {Attributes.ATTRIBUTE_INDEXED, Boolean}
      - {Attributes.ATTRIBUTE_TYPE, Integer}
      - Where value of ATTRIBUTE_TYPE is
        - FdkConstants.ATTRIBUTE_TYPE_STRING
        - FdkConstants.ATTRIBUTE_TYPE_STRING_ARRAY
        - FdkConstants.ATTRIBUTE_TYPE_DATE
        - FdkConstants.ATTRIBUTE_TYPE_INTEGER
        - FdkConstants.ATTRIBUTE_TYPE_LONG
        - FdkConstants.ATTRIBUTE_TYPE_BOOLEAN
        - FdkConstants.ATTRIBUTE_TYPE_FLOAT
        - FdkConstants.ATTRIBUTE_TYPE_USER
        - FdkConstants.ATTRIBUTE_TYPE_GROUP
      - {Attributes.ATTRIBUTE_DEFAULT, type, where type is String, String [], date, int, long, boolean, float or double}
      - {Attributes.ATTRIBUTE_ENUMERATION, [] type, where type is String, int, or long}
    - {Attributes.REQUEST_JUSTIFICATION, String}
    `attrrequest` - requested attributes for each item, or null.
  Returns:
    id of the newly created subclass
  Throws:
    `FdkException` - if the operation fails

### modifyCategorySubClass

    public Item modifyCategorySubClass(long mdscatId,
                                       NamedValue[] attributes,
                                       AttributeRequest[] attrrequest)
                                throws FdkException

  Description copied from interface: `CategoryManager`
  Modifies the given Category subclass.

    `attributes` - array of attributes for creating the category class
    - notation: {Attribute name, Attribute type}
    - {Attributes.NAME, String}
    - {Attributes.DESCRIPTION, String}
    - {Attributes.CLASS_HIDDEN, Boolean}
    - {Attributes.CATEGORY_COPY_ON_VERSION, Boolean}
  Throws:
    `FdkException` - if the operation fails

### freeCategoryClass

    public void freeCategoryClass(long mdscatId)
                           throws FdkException

  Description copied from class: `CoreCategoryManager`
  Frees a category class.

  Parameters:
    `mdscatId` -
  Throws:
    `FdkException`

### removeCategoryAttribute

    public void removeCategoryAttribute(long categoryId,
                                        java.lang.String attributename)
                                 throws FdkException

  Deprecated. use removeMetaDataAttribute

  Description copied from class: `CoreCategoryManager`
  removes a category attribute.

  Parameters:
    `categoryId` -
    `attributename` - name of attribute to be removed.

  Throws:
    `FdkException`

### setMetaDataConfiguration

    protected void setMetaDataConfiguration(long folderId,
                                            NamedValue[] config,
                                            java.lang.String configClassName)
                                     throws FdkException

  Throws:
    `FdkException`

### removeMetaDataConfiguration

    protected void removeMetaDataConfiguration(long folderId,
                                               java.lang.String configClassName)
                                        throws FdkException

  Throws:
    `FdkException`

### getRequiredMetaDataCategories

    protected Item[] getRequiredMetaDataCategories(long folderId,
                                                   AttributeRequest[] attrReqs,
                                                   java.lang.String cfgClassName)
                                            throws FdkException

  Description copied from class: `CoreCategoryManager`
  Returns the RequiredCategories of the given folder, or null if none.

  Parameters:
    `folderId` - Id of folder in question
    `attrReqs` - Array of AttributeRequests.
    `cfgClassName` - name of Configuration Class (Record/AdHoc)
  Returns:
    an array of RequiredCategory Items
  Throws:
    `FdkException` - if operation fails

### getConfigurationMetaDataCategories

    protected Item[] getConfigurationMetaDataCategories(long folderId,
                                                        int categorytype,
                                                        AttributeRequest[] requestedAttributes,
                                                        java.lang.String configClassName)
                                                 throws FdkException

  Deprecated. remove when getRequiredCategories is removed.

  Description copied from class: `CoreCategoryManager`
  gets REQUIRED category classes from a given configuration (which is either AdHocConfiguration or RecordConfiguration)

  Parameters:
    `folderId` -
    `categorytype` - (only supports REQUIRED now.)
    `requestedAttributes` -
    `configClassName` -
  Returns:

  Throws:
    `FdkException`

### addMetaDataAttribute

    public Item addMetaDataAttribute(long categoryId,
                                     NamedValue attributedef,
                                     AttributeRequest[] attrrequest)
                              throws FdkException

  Description copied from class: `CoreCategoryManager`
  adds a metadata attribute.

  Parameters:
    `categoryId` -
    `attributedef` -
    `attrrequest` -
  Returns:

  Throws:
    `FdkException`

### addMetaDataCategoryAttribute

    protected Item addMetaDataCategoryAttribute(long categoryId,
                                                NamedValue attributedef,
                                                AttributeRequest[] attrrequest)
                                         throws FdkException

  Deprecated. use addMetaDataAttribute

  Description copied from class: `CoreCategoryManager`
  adds a category attribute.

  Parameters:
    `categoryId` -
    `attributedef` -
    `attrrequest` -
  Returns:

  Throws:
    `FdkException`

### modifyMetaDataAttribute

    public Item modifyMetaDataAttribute(long attributeId,
                                        NamedValue attributedef,
                                        AttributeRequest[] attrrequest)
                                 throws FdkException

  Description copied from class: `CoreCategoryManager`
  modify a category attribute.

  Parameters:
    `attributeId` -
    `attributedef` -
    `attrrequest` - requested attributes of the Attribute
  Returns:
    the Attribute as an item

  Throws:
    `FdkException`

### removeMetaDataAttribute

    public void removeMetaDataAttribute(long attributeId)
                                 throws FdkException

  Description copied from class: `CoreCategoryManager`
  removes a category attribute.

  Parameters:
    `attributeId` -

  Throws:
    `FdkException`

### removeMetaDataCategoryAttribute

    protected void removeMetaDataCategoryAttribute(long categoryId,
                                                   java.lang.String attributeName)
                                            throws FdkException

  Deprecated. use removeMetaDataAttribute

  Description copied from class: `CoreCategoryManager`
  removes a category attribute.

  Parameters:
    `categoryId` - - id of Category Class Object with attribute
    `attributeName` - name of attribute to be removed

  Throws:
    `FdkException`

### checkInvalidAttributes

    protected void checkInvalidAttributes(java.util.Map attrMap)
                                   throws FdkException

  Description copied from class: `CoreCategoryManager`
  if any attributes remain, then they are invalid

  Parameters:
    `attrMap` -
  Throws:
    `FdkException`

### isWebServiceCall

    protected final boolean isWebServiceCall()

  Returns `true` if the current call was made from a web services client. This check can be made by any subclasses in order to determine functionality and restrictions based on the originating call. This feature should be used lightly and only where really necessary as this is not an idea way of implementing business logic.

### referenceTypes

    public void referenceTypes(TypeReference ref)

  Dummy web service method to create a reference to data types used in the web services to insure that they are defined in the WSDL.

### login

    protected final NamedValue[] login(FdkCredential c,
                                       NamedValue[] options,
                                       AttributeRequest[] userAttributes)
                                throws FdkException

  Internal login method used by web services login managers.

  Throws:
    `FdkException`

### getConnectedSession

    protected final FdkSessionImpl getConnectedSession()
                                                throws FdkException

  Return the web service session. The return value is guaranteed to be non-null and to represent a connected session. If the client is not authenticated an FdkException is thrown.

  Throws:
    `FdkException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD